require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_SPARC_ATOMIC__)) {
    eval 'sub __ARCH_SPARC_ATOMIC__ () {1;}' unless defined(&__ARCH_SPARC_ATOMIC__);
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub ATOMIC_INIT {
	    local($i) = @_;
    	    eval q({ ($i) });
	}' unless defined(&ATOMIC_INIT);
	eval 'sub atomic_read {
	    local($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic_add {
	    local($i, $v) = @_;
    	    eval q((( &void) &__atomic_add_return( ($i), ($v))));
	}' unless defined(&atomic_add);
	eval 'sub atomic_sub {
	    local($i, $v) = @_;
    	    eval q((( &void) &__atomic_add_return(-($i), ($v))));
	}' unless defined(&atomic_sub);
	eval 'sub atomic_inc {
	    local($v) = @_;
    	    eval q((( &void) &__atomic_add_return( 1, ($v))));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_dec {
	    local($v) = @_;
    	    eval q((( &void) &__atomic_add_return( -1, ($v))));
	}' unless defined(&atomic_dec);
	eval 'sub atomic_add_return {
	    local($i, $v) = @_;
    	    eval q(( &__atomic_add_return( ($i), ($v))));
	}' unless defined(&atomic_add_return);
	eval 'sub atomic_sub_return {
	    local($i, $v) = @_;
    	    eval q(( &__atomic_add_return(-($i), ($v))));
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic_inc_return {
	    local($v) = @_;
    	    eval q(( &__atomic_add_return( 1, ($v))));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_dec_return {
	    local($v) = @_;
    	    eval q(( &__atomic_add_return( -1, ($v))));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_dec_and_test {
	    local($v) = @_;
    	    eval q(( &atomic_dec_return($v) == 0));
	}' unless defined(&atomic_dec_and_test);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub ATOMIC24_INIT {
	        local($i) = @_;
    		eval q({ ($i) });
	    }' unless defined(&ATOMIC24_INIT);
	    eval 'sub atomic24_read {
	        local($v) = @_;
    		eval q((($v)-> &counter));
	    }' unless defined(&atomic24_read);
	    eval 'sub atomic24_set {
	        local($v, $i) = @_;
    		eval q(((($v)-> &counter) = $i));
	    }' unless defined(&atomic24_set);
	} else {
	    eval 'sub ATOMIC24_INIT {
	        local($i) = @_;
    		eval q({ (($i) << 8) });
	    }' unless defined(&ATOMIC24_INIT);
	    eval 'sub atomic24_read {
	        local($v) = @_;
    		eval q({ \'int\'  &ret =  ($v->{counter});  &while( &ret & 0xff)  &ret =  ($v->{counter});  &ret >> 8; });
	    }' unless defined(&atomic24_read);
	    eval 'sub atomic24_set {
	        local($v, $i) = @_;
    		eval q(((($v)-> &counter) = (($i) << 8)));
	    }' unless defined(&atomic24_set);
	}
	eval 'sub __atomic24_add {
	    local($i,$v) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &register \'int\'  &tmp1  &asm(\\"g3\\");  &register \'int\'  &tmp2  &asm(\\"g4\\");  &register \'int\'  &tmp3  &asm(\\"g7\\");  &ptr =  ($v->{counter});  &increment = $i;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_add\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\" : \\"=&r\\" ( &increment), \\"=r\\" ( &tmp1), \\"=r\\" ( &tmp2), \\"=r\\" ( &tmp3) : \\"0\\" ( &increment), \\"r\\" ( &ptr) : \\"memory\\", \\"cc\\");  &increment; });
	}' unless defined(&__atomic24_add);
	eval 'sub __atomic24_sub {
	    local($i,$v) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &register \'int\'  &tmp1  &asm(\\"g3\\");  &register \'int\'  &tmp2  &asm(\\"g4\\");  &register \'int\'  &tmp3  &asm(\\"g7\\");  &ptr =  ($v->{counter});  &increment = $i;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_sub\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\" : \\"=&r\\" ( &increment), \\"=r\\" ( &tmp1), \\"=r\\" ( &tmp2), \\"=r\\" ( &tmp3) : \\"0\\" ( &increment), \\"r\\" ( &ptr) : \\"memory\\", \\"cc\\");  &increment; });
	}' unless defined(&__atomic24_sub);
	eval 'sub atomic24_add {
	    local($i, $v) = @_;
    	    eval q((( &void) &__atomic24_add(($i), ($v))));
	}' unless defined(&atomic24_add);
	eval 'sub atomic24_sub {
	    local($i, $v) = @_;
    	    eval q((( &void) &__atomic24_sub(($i), ($v))));
	}' unless defined(&atomic24_sub);
	eval 'sub atomic24_dec_return {
	    local($v) = @_;
    	    eval q( &__atomic24_sub(1, ($v)));
	}' unless defined(&atomic24_dec_return);
	eval 'sub atomic24_inc_return {
	    local($v) = @_;
    	    eval q( &__atomic24_add(1, ($v)));
	}' unless defined(&atomic24_inc_return);
	eval 'sub atomic24_sub_and_test {
	    local($i, $v) = @_;
    	    eval q(( &__atomic24_sub(($i), ($v)) == 0));
	}' unless defined(&atomic24_sub_and_test);
	eval 'sub atomic24_dec_and_test {
	    local($v) = @_;
    	    eval q(( &__atomic24_sub(1, ($v)) == 0));
	}' unless defined(&atomic24_dec_and_test);
	eval 'sub atomic24_inc {
	    local($v) = @_;
    	    eval q((( &void) &__atomic24_add(1, ($v))));
	}' unless defined(&atomic24_inc);
	eval 'sub atomic24_dec {
	    local($v) = @_;
    	    eval q((( &void) &__atomic24_sub(1, ($v))));
	}' unless defined(&atomic24_dec);
	eval 'sub atomic24_add_negative {
	    local($i, $v) = @_;
    	    eval q(( &__atomic24_add(($i), ($v)) < 0));
	}' unless defined(&atomic24_add_negative);
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
}
1;
