require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PGTSRMMU_H)) {
    eval 'sub _SPARC_PGTSRMMU_H () {1;}' unless defined(&_SPARC_PGTSRMMU_H);
    require 'asm/page.ph';
    if(defined(&__ASSEMBLY__)) {
	require 'asm/thread_info.ph';
    }
    eval 'sub SRMMU_MAX_CONTEXTS () {65536;}' unless defined(&SRMMU_MAX_CONTEXTS);
    eval 'sub SRMMU_PMD_SHIFT () {18;}' unless defined(&SRMMU_PMD_SHIFT);
    eval 'sub SRMMU_PMD_SIZE () {(1 <<  &SRMMU_PMD_SHIFT);}' unless defined(&SRMMU_PMD_SIZE);
    eval 'sub SRMMU_PMD_MASK () {(~( &SRMMU_PMD_SIZE-1));}' unless defined(&SRMMU_PMD_MASK);
    eval 'sub SRMMU_PGDIR_SHIFT () {24;}' unless defined(&SRMMU_PGDIR_SHIFT);
    eval 'sub SRMMU_PGDIR_SIZE () {(1 <<  &SRMMU_PGDIR_SHIFT);}' unless defined(&SRMMU_PGDIR_SIZE);
    eval 'sub SRMMU_PGDIR_MASK () {(~( &SRMMU_PGDIR_SIZE-1));}' unless defined(&SRMMU_PGDIR_MASK);
    eval 'sub SRMMU_PGDIR_ALIGN {
        local($addr) = @_;
	    eval q(((($addr)+ &SRMMU_PGDIR_SIZE-1) &SRMMU_PGDIR_MASK));
    }' unless defined(&SRMMU_PGDIR_ALIGN);
    eval 'sub SRMMU_PTRS_PER_PTE () {64;}' unless defined(&SRMMU_PTRS_PER_PTE);
    eval 'sub SRMMU_PTRS_PER_PMD () {64;}' unless defined(&SRMMU_PTRS_PER_PMD);
    eval 'sub SRMMU_PTRS_PER_PGD () {256;}' unless defined(&SRMMU_PTRS_PER_PGD);
    eval 'sub SRMMU_PTE_TABLE_SIZE () {0x100;}' unless defined(&SRMMU_PTE_TABLE_SIZE);
    eval 'sub SRMMU_PMD_TABLE_SIZE () {0x100;}' unless defined(&SRMMU_PMD_TABLE_SIZE);
    eval 'sub SRMMU_PGD_TABLE_SIZE () {0x400;}' unless defined(&SRMMU_PGD_TABLE_SIZE);
    eval 'sub SRMMU_PTRS_PER_PTE_SOFT () {( &PAGE_SIZE/4);}' unless defined(&SRMMU_PTRS_PER_PTE_SOFT);
    eval 'sub SRMMU_PTRS_PER_PMD_SOFT () {4;}' unless defined(&SRMMU_PTRS_PER_PMD_SOFT);
    eval 'sub SRMMU_PTE_SZ_SOFT () { &PAGE_SIZE;}' unless defined(&SRMMU_PTE_SZ_SOFT);
    eval 'sub SRMMU_PMD_SHIFT_SOFT () {22;}' unless defined(&SRMMU_PMD_SHIFT_SOFT);
    eval 'sub SRMMU_PMD_SIZE_SOFT () {(1 <<  &SRMMU_PMD_SHIFT_SOFT);}' unless defined(&SRMMU_PMD_SIZE_SOFT);
    eval 'sub SRMMU_PMD_MASK_SOFT () {(~( &SRMMU_PMD_SIZE_SOFT-1));}' unless defined(&SRMMU_PMD_MASK_SOFT);
    eval 'sub SRMMU_PMD_ALIGN_SOFT {
        local($addr) = @_;
	    eval q(((($addr)+ &SRMMU_PMD_SIZE_SOFT-1) &SRMMU_PMD_MASK_SOFT));
    }' unless defined(&SRMMU_PMD_ALIGN_SOFT);
    eval 'sub SRMMU_ET_MASK () {0x3;}' unless defined(&SRMMU_ET_MASK);
    eval 'sub SRMMU_ET_INVALID () {0x;}' unless defined(&SRMMU_ET_INVALID);
    eval 'sub SRMMU_ET_PTD () {0x1;}' unless defined(&SRMMU_ET_PTD);
    eval 'sub SRMMU_ET_PTE () {0x2;}' unless defined(&SRMMU_ET_PTE);
    eval 'sub SRMMU_ET_REPTE () {0x3;}' unless defined(&SRMMU_ET_REPTE);
    eval 'sub SRMMU_CTX_PMASK () {0xfffffff0;}' unless defined(&SRMMU_CTX_PMASK);
    eval 'sub SRMMU_PTD_PMASK () {0xfffffff0;}' unless defined(&SRMMU_PTD_PMASK);
    eval 'sub SRMMU_PTE_PMASK () {0xffffff00;}' unless defined(&SRMMU_PTE_PMASK);
    eval 'sub SRMMU_CACHE () {0x80;}' unless defined(&SRMMU_CACHE);
    eval 'sub SRMMU_DIRTY () {0x40;}' unless defined(&SRMMU_DIRTY);
    eval 'sub SRMMU_REF () {0x20;}' unless defined(&SRMMU_REF);
    eval 'sub SRMMU_EXEC () {0x8;}' unless defined(&SRMMU_EXEC);
    eval 'sub SRMMU_WRITE () {0x4;}' unless defined(&SRMMU_WRITE);
    eval 'sub SRMMU_VALID () {0x2;}' unless defined(&SRMMU_VALID);
    eval 'sub SRMMU_PRIV () {0x1c;}' unless defined(&SRMMU_PRIV);
    eval 'sub SRMMU_PRIV_RDONLY () {0x18;}' unless defined(&SRMMU_PRIV_RDONLY);
    eval 'sub SRMMU_FILE () {0x40;}' unless defined(&SRMMU_FILE);
    eval 'sub SRMMU_PTE_FILE_SHIFT () {8;}' unless defined(&SRMMU_PTE_FILE_SHIFT);
    eval 'sub SRMMU_CHG_MASK () {(0xffffff00 |  &SRMMU_REF |  &SRMMU_DIRTY);}' unless defined(&SRMMU_CHG_MASK);
    eval 'sub SRMMU_PAGE_NONE () { &__pgprot( &SRMMU_VALID |  &SRMMU_CACHE |  &SRMMU_PRIV |  &SRMMU_REF);}' unless defined(&SRMMU_PAGE_NONE);
    eval 'sub SRMMU_PAGE_SHARED () { &__pgprot( &SRMMU_VALID |  &SRMMU_CACHE |  &SRMMU_EXEC |  &SRMMU_WRITE |  &SRMMU_REF);}' unless defined(&SRMMU_PAGE_SHARED);
    eval 'sub SRMMU_PAGE_COPY () { &__pgprot( &SRMMU_VALID |  &SRMMU_CACHE |  &SRMMU_EXEC |  &SRMMU_REF);}' unless defined(&SRMMU_PAGE_COPY);
    eval 'sub SRMMU_PAGE_RDONLY () { &__pgprot( &SRMMU_VALID |  &SRMMU_CACHE |  &SRMMU_EXEC |  &SRMMU_REF);}' unless defined(&SRMMU_PAGE_RDONLY);
    eval 'sub SRMMU_PAGE_KERNEL () { &__pgprot( &SRMMU_VALID |  &SRMMU_CACHE |  &SRMMU_PRIV |  &SRMMU_DIRTY |  &SRMMU_REF);}' unless defined(&SRMMU_PAGE_KERNEL);
    eval 'sub SRMMU_CTRL_REG () {0x;}' unless defined(&SRMMU_CTRL_REG);
    eval 'sub SRMMU_CTXTBL_PTR () {0x100;}' unless defined(&SRMMU_CTXTBL_PTR);
    eval 'sub SRMMU_CTX_REG () {0x200;}' unless defined(&SRMMU_CTX_REG);
    eval 'sub SRMMU_FAULT_STATUS () {0x300;}' unless defined(&SRMMU_FAULT_STATUS);
    eval 'sub SRMMU_FAULT_ADDR () {0x400;}' unless defined(&SRMMU_FAULT_ADDR);
    eval 'sub WINDOW_FLUSH {
        local($tmp1, $tmp2) = @_;
	    eval q( &mov 0, $tmp1; 98:  &ld [% &g6 +  &TI_UWINMASK], $tmp2;  &orcc % &g0, $tmp2, % &g0;  &add $tmp1, 1, $tmp1;  &bne 98 &b;  &save % &sp, -64, % &sp; 99:  &subcc $tmp1, 1, $tmp1;  &bne 99 &b;  &restore % &g0, % &g0, % &g0;);
    }' unless defined(&WINDOW_FLUSH);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub __nocache_pa {
	    local($VADDR) = @_;
    	    eval q(( -  &SRMMU_NOCACHE_VADDR +  &__pa( &srmmu_nocache_pool)));
	}' unless defined(&__nocache_pa);
	eval 'sub __nocache_va {
	    local($PADDR) = @_;
    	    eval q(( &__va -  &srmmu_nocache_pool +  &SRMMU_NOCACHE_VADDR));
	}' unless defined(&__nocache_va);
	eval 'sub __nocache_fix {
	    local($VADDR) = @_;
    	    eval q( &__va( &__nocache_pa($VADDR)));
	}' unless defined(&__nocache_fix);
	eval 'sub srmmu_set_mmureg {
	    local($regval) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"sta %0, [%%g0] %1\\\\n\\\\t\\" : : \\"r\\" ($regval), \\"i\\" ( &ASI_M_MMUREGS) : \\"memory\\"); });
	}' unless defined(&srmmu_set_mmureg);
	eval 'sub srmmu_set_ctable_ptr {
	    local($paddr) = @_;
    	    eval q({ $paddr = (($paddr >> 4) &  &SRMMU_CTX_PMASK);  &__asm__  &__volatile__(\\"sta %0, [%1] %2\\\\n\\\\t\\" : : \\"r\\" ($paddr), \\"r\\" ( &SRMMU_CTXTBL_PTR), \\"i\\" ( &ASI_M_MMUREGS) : \\"memory\\"); });
	}' unless defined(&srmmu_set_ctable_ptr);
	eval 'sub srmmu_get_ctable_ptr {
	    local($void) = @_;
    	    eval q({ my $retval;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $retval) : \\"r\\" ( &SRMMU_CTXTBL_PTR), \\"i\\" ( &ASI_M_MMUREGS)); ( $retval &  &SRMMU_CTX_PMASK) << 4; });
	}' unless defined(&srmmu_get_ctable_ptr);
	eval 'sub srmmu_set_context {
	    local($context) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"sta %0, [%1] %2\\\\n\\\\t\\" : : \\"r\\" ($context), \\"r\\" ( &SRMMU_CTX_REG), \\"i\\" ( &ASI_M_MMUREGS) : \\"memory\\"); });
	}' unless defined(&srmmu_set_context);
	eval 'sub srmmu_get_context {
	    local($void) = @_;
    	    eval q({  &register \'int\'  &retval;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( &retval) : \\"r\\" ( &SRMMU_CTX_REG), \\"i\\" ( &ASI_M_MMUREGS));  &retval; });
	}' unless defined(&srmmu_get_context);
	eval 'sub srmmu_get_fstatus {
	    local($void) = @_;
    	    eval q({ my $retval;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $retval) : \\"r\\" ( &SRMMU_FAULT_STATUS), \\"i\\" ( &ASI_M_MMUREGS));  $retval; });
	}' unless defined(&srmmu_get_fstatus);
	eval 'sub srmmu_get_faddr {
	    local($void) = @_;
    	    eval q({ my $retval;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $retval) : \\"r\\" ( &SRMMU_FAULT_ADDR), \\"i\\" ( &ASI_M_MMUREGS));  $retval; });
	}' unless defined(&srmmu_get_faddr);
	eval 'sub srmmu_flush_tlb_region {
	    local($addr) = @_;
    	    eval q({ $addr &=  &SRMMU_PGDIR_MASK;  &__asm__  &__volatile__(\\"sta %%g0, [%0] %1\\\\n\\\\t\\": : \\"r\\" ($addr | 0x200), \\"i\\" ( &ASI_M_FLUSH_PROBE) : \\"memory\\"); });
	}' unless defined(&srmmu_flush_tlb_region);
	eval 'sub srmmu_flush_tlb_segment {
	    local($addr) = @_;
    	    eval q({ $addr &=  &SRMMU_PMD_MASK;  &__asm__  &__volatile__(\\"sta %%g0, [%0] %1\\\\n\\\\t\\": : \\"r\\" ($addr | 0x100), \\"i\\" ( &ASI_M_FLUSH_PROBE) : \\"memory\\"); });
	}' unless defined(&srmmu_flush_tlb_segment);
	eval 'sub srmmu_flush_tlb_page {
	    local($page) = @_;
    	    eval q({ $page &=  &PAGE_MASK;  &__asm__  &__volatile__(\\"sta %%g0, [%0] %1\\\\n\\\\t\\": : \\"r\\" ($page), \\"i\\" ( &ASI_M_FLUSH_PROBE) : \\"memory\\"); });
	}' unless defined(&srmmu_flush_tlb_page);
	eval 'sub srmmu_hwprobe {
	    local($vaddr) = @_;
    	    eval q({ my $retval; $vaddr &=  &PAGE_MASK;  &__asm__  &__volatile__(\\"lda [%1] %2, %0\\\\n\\\\t\\" : \\"=r\\" ( $retval) : \\"r\\" ($vaddr | 0x400), \\"i\\" ( &ASI_M_FLUSH_PROBE));  $retval; });
	}' unless defined(&srmmu_hwprobe);
	eval 'sub srmmu_get_pte {
	    local($addr) = @_;
    	    eval q({  &register my $entry;  &__asm__  &__volatile__(\\"\\\\n\\\\tlda [%1] %2,%0\\\\n\\\\t\\" : \\"=r\\" ( $entry): \\"r\\" (($addr & 0xfffff000) | 0x400), \\"i\\" ( &ASI_M_FLUSH_PROBE));  $entry; });
	}' unless defined(&srmmu_get_pte);
    }
}
1;
