require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_SEMAPHORE_H)) {
    eval 'sub _SPARC_SEMAPHORE_H () {1;}' unless defined(&_SPARC_SEMAPHORE_H);
    if(defined(&__KERNEL__)) {
	require 'asm/atomic.ph';
	require 'linux/wait.ph';
	require 'linux/rwsem.ph';
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	    eval 'sub __SEM_DEBUG_INIT {
	        local($name) = @_;
    		eval q(, ($name). &__magic);
	    }' unless defined(&__SEM_DEBUG_INIT);
	} else {
	    eval 'sub __SEM_DEBUG_INIT {
	        local($name) = @_;
    		eval q();
	    }' unless defined(&__SEM_DEBUG_INIT);
	}
	eval 'sub __SEMAPHORE_INITIALIZER {
	    local($name,$count) = @_;
    	    eval q({  &ATOMIC24_INIT($count), 0,  &__WAIT_QUEUE_HEAD_INITIALIZER(($name). &wait)  &__SEM_DEBUG_INIT($name) });
	}' unless defined(&__SEMAPHORE_INITIALIZER);
	eval 'sub __MUTEX_INITIALIZER {
	    local($name) = @_;
    	    eval q( &__SEMAPHORE_INITIALIZER($name,1));
	}' unless defined(&__MUTEX_INITIALIZER);
	eval 'sub __DECLARE_SEMAPHORE_GENERIC {
	    local($name,$count) = @_;
    	    eval q(\'struct semaphore\' $name =  &__SEMAPHORE_INITIALIZER($name,$count));
	}' unless defined(&__DECLARE_SEMAPHORE_GENERIC);
	eval 'sub DECLARE_MUTEX {
	    local($name) = @_;
    	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,1));
	}' unless defined(&DECLARE_MUTEX);
	eval 'sub DECLARE_MUTEX_LOCKED {
	    local($name) = @_;
    	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,0));
	}' unless defined(&DECLARE_MUTEX_LOCKED);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub sema_init {
	    local($sem,$val) = @_;
    	    eval q({  &atomic24_set( ($sem->{count}), $val);  ($sem->{sleepers}) = 0;  &init_waitqueue_head( ($sem->{wait})); });
	}' unless defined(&sema_init);
	eval 'sub init_MUTEX {
	    local($sem) = @_;
    	    eval q({  &sema_init($sem, 1); });
	}' unless defined(&init_MUTEX);
	eval 'sub init_MUTEX_LOCKED {
	    local($sem) = @_;
    	    eval q({  &sema_init($sem, 0); });
	}' unless defined(&init_MUTEX_LOCKED);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down {
	    local($sem) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &might_sleep();  &ptr = ( ($sem->{count}->{counter}));  &increment = 1;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_sub\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\\\t\\" \\"tst	%%g2\\\\n\\\\t\\" \\"bl	2f\\\\n\\\\t\\" \\" nop\\\\n\\" \\"1:\\\\n\\\\t\\" \\".subsection 2\\\\n\\" \\"2:\\\\n\\\\t\\" \\"save	%%sp, -64, %%sp\\\\n\\\\t\\" \\"mov	%%g1, %%l1\\\\n\\\\t\\" \\"mov	%%g5, %%l5\\\\n\\\\t\\" \\"call	%3\\\\n\\\\t\\" \\" mov	%%g1, %%o0\\\\n\\\\t\\" \\"mov	%%l1, %%g1\\\\n\\\\t\\" \\"ba	1b\\\\n\\\\t\\" \\" restore %%l5, %%g0, %%g5\\\\n\\\\t\\" \\".previous\\\\n\\" : \\"=&r\\" ( &increment) : \\"0\\" ( &increment), \\"r\\" ( &ptr), \\"i\\" ( &__down) : \\"g3\\", \\"g4\\", \\"g7\\", \\"memory\\", \\"cc\\"); });
	}' unless defined(&down);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down_interruptible {
	    local($sem) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &might_sleep();  &ptr = ( ($sem->{count}->{counter}));  &increment = 1;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_sub\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\\\t\\" \\"tst	%%g2\\\\n\\\\t\\" \\"bl	2f\\\\n\\\\t\\" \\" clr	%%g2\\\\n\\" \\"1:\\\\n\\\\t\\" \\".subsection 2\\\\n\\" \\"2:\\\\n\\\\t\\" \\"save	%%sp, -64, %%sp\\\\n\\\\t\\" \\"mov	%%g1, %%l1\\\\n\\\\t\\" \\"mov	%%g5, %%l5\\\\n\\\\t\\" \\"call	%3\\\\n\\\\t\\" \\" mov	%%g1, %%o0\\\\n\\\\t\\" \\"mov	%%l1, %%g1\\\\n\\\\t\\" \\"mov	%%l5, %%g5\\\\n\\\\t\\" \\"ba	1b\\\\n\\\\t\\" \\" restore %%o0, %%g0, %%g2\\\\n\\\\t\\" \\".previous\\\\n\\" : \\"=&r\\" ( &increment) : \\"0\\" ( &increment), \\"r\\" ( &ptr), \\"i\\" ( &__down_interruptible) : \\"g3\\", \\"g4\\", \\"g7\\", \\"memory\\", \\"cc\\");  &increment; });
	}' unless defined(&down_interruptible);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down_trylock {
	    local($sem) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &ptr = ( ($sem->{count}->{counter}));  &increment = 1;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_sub\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\\\t\\" \\"tst	%%g2\\\\n\\\\t\\" \\"bl	2f\\\\n\\\\t\\" \\" clr	%%g2\\\\n\\" \\"1:\\\\n\\\\t\\" \\".subsection 2\\\\n\\" \\"2:\\\\n\\\\t\\" \\"save	%%sp, -64, %%sp\\\\n\\\\t\\" \\"mov	%%g1, %%l1\\\\n\\\\t\\" \\"mov	%%g5, %%l5\\\\n\\\\t\\" \\"call	%3\\\\n\\\\t\\" \\" mov	%%g1, %%o0\\\\n\\\\t\\" \\"mov	%%l1, %%g1\\\\n\\\\t\\" \\"mov	%%l5, %%g5\\\\n\\\\t\\" \\"ba	1b\\\\n\\\\t\\" \\" restore %%o0, %%g0, %%g2\\\\n\\\\t\\" \\".previous\\\\n\\" : \\"=&r\\" ( &increment) : \\"0\\" ( &increment), \\"r\\" ( &ptr), \\"i\\" ( &__down_trylock) : \\"g3\\", \\"g4\\", \\"g7\\", \\"memory\\", \\"cc\\");  &increment; });
	}' unless defined(&down_trylock);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub up {
	    local($sem) = @_;
    	    eval q({  &register  &volatile \'int\' * &ptr  &asm(\\"g1\\");  &register \'int\'  &increment  &asm(\\"g2\\");  &ptr = ( ($sem->{count}->{counter}));  &increment = 1;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___atomic24_add\\\\n\\\\t\\" \\" add	%%o7, 8, %%o7\\\\n\\\\t\\" \\"tst	%%g2\\\\n\\\\t\\" \\"ble	2f\\\\n\\\\t\\" \\" nop\\\\n\\" \\"1:\\\\n\\\\t\\" \\".subsection 2\\\\n\\" \\"2:\\\\n\\\\t\\" \\"save	%%sp, -64, %%sp\\\\n\\\\t\\" \\"mov	%%g1, %%l1\\\\n\\\\t\\" \\"mov	%%g5, %%l5\\\\n\\\\t\\" \\"call	%3\\\\n\\\\t\\" \\" mov	%%g1, %%o0\\\\n\\\\t\\" \\"mov	%%l1, %%g1\\\\n\\\\t\\" \\"ba	1b\\\\n\\\\t\\" \\" restore %%l5, %%g0, %%g5\\\\n\\\\t\\" \\".previous\\\\n\\" : \\"=&r\\" ( &increment) : \\"0\\" ( &increment), \\"r\\" ( &ptr), \\"i\\" ( &__up) : \\"g3\\", \\"g4\\", \\"g7\\", \\"memory\\", \\"cc\\"); } );
	}' unless defined(&up);
    }
}
1;
