require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_SMP_H)) {
    eval 'sub _SPARC_SMP_H () {1;}' unless defined(&_SPARC_SMP_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'asm/head.ph';
    require 'asm/btfixup.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/cpumask.ph';
    }
    if(defined(&CONFIG_SMP)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/ptrace.ph';
	    require 'asm/asi.ph';
	    require 'asm/atomic.ph';
	    eval 'sub cpu_possible_map () { &phys_cpu_present_map;}' unless defined(&cpu_possible_map);
	    eval 'sub smp_boot_one_cpu {
	        local($__cpu) = @_;
    		eval q( &BTFIXUP_CALL( &smp_boot_one_cpu)($__cpu));
	    }' unless defined(&smp_boot_one_cpu);
	    eval 'sub smp_cross_call {
	        local($func,$arg1,$arg2,$arg3,$arg4,$arg5) = @_;
    		eval q( &BTFIXUP_CALL( &smp_cross_call)($func,$arg1,$arg2,$arg3,$arg4,$arg5));
	    }' unless defined(&smp_cross_call);
	    eval 'sub smp_message_pass {
	        local($target,$msg,$data,$wait) = @_;
    		eval q( &BTFIXUP_CALL( &smp_message_pass)($target,$msg,$data,$wait));
	    }' unless defined(&smp_message_pass);
	    eval 'sub xc2 {
	        local($func,$arg1,$arg2) = @_;
    		eval q({  &smp_cross_call($func, $arg1, $arg2, 0, 0, 0); });
	    }' unless defined(&xc2);
	    eval 'sub xc3 {
	        local($func,$arg1,$arg2,$arg3) = @_;
    		eval q({  &smp_cross_call($func, $arg1, $arg2, $arg3, 0, 0); });
	    }' unless defined(&xc3);
	    eval 'sub xc4 {
	        local($func,$arg1,$arg2,$arg3,$arg4) = @_;
    		eval q({  &smp_cross_call($func, $arg1, $arg2, $arg3, $arg4, 0); });
	    }' unless defined(&xc4);
	    eval 'sub xc5 {
	        local($func,$arg1,$arg2,$arg3,$arg4,$arg5) = @_;
    		eval q({  &smp_cross_call($func, $arg1, $arg2, $arg3, $arg4, $arg5); });
	    }' unless defined(&xc5);
	    eval 'sub smp_call_function {
	        eval q(( &void (* &func)( &void * &info),  &void * &info, \'int\'  &nonatomic, \'int\'  &wait) {  &xc1(( &smpfunc_t) &func,  &info); 0; });
	    }' unless defined(&smp_call_function);
	    eval 'sub cpu_logical_map {
	        local($cpu) = @_;
    		eval q({  $__cpu_logical_map[$cpu]; });
	    }' unless defined(&cpu_logical_map);
	    eval 'sub cpu_number_map {
	        local($cpu) = @_;
    		eval q({  $__cpu_number_map[$cpu]; });
	    }' unless defined(&cpu_number_map);
	    eval 'sub hard_smp4m_processor_id {
	        local($void) = @_;
    		eval q({ \'int\'  &cpuid;  &__asm__  &__volatile__(\\"rd %%tbr, %0\\\\n\\\\t\\" \\"srl %0, 12, %0\\\\n\\\\t\\" \\"and %0, 3, %0\\\\n\\\\t\\" : \\"=&r\\" ( &cpuid));  &cpuid; });
	    }' unless defined(&hard_smp4m_processor_id);
	    eval 'sub hard_smp4d_processor_id {
	        local($void) = @_;
    		eval q({ \'int\'  &cpuid;  &__asm__  &__volatile__(\\"lda [%%g0] %1, %0\\\\n\\\\t\\" : \\"=&r\\" ( &cpuid) : \\"i\\" ( &ASI_M_VIKING_TMP1));  &cpuid; });
	    }' unless defined(&hard_smp4d_processor_id);
	    unless(defined(&MODULE)) {
		eval 'sub hard_smp_processor_id {
		    local($void) = @_;
    		    eval q({ \'int\'  &cpuid;  &__asm__  &__volatile__(\\"sethi %%hi(___b_hard_smp_processor_id), %0\\\\n\\\\t\\" \\"sethi %%hi(boot_cpu_id), %0\\\\n\\\\t\\" \\"ldub [%0 + %%lo(boot_cpu_id)], %0\\\\n\\\\t\\" : \\"=&r\\" ( &cpuid));  &cpuid; });
		}' unless defined(&hard_smp_processor_id);
	    } else {
		eval 'sub hard_smp_processor_id {
		    local($void) = @_;
    		    eval q({ \'int\'  &cpuid;  &__asm__  &__volatile__(\\"mov %%o7, %%g1\\\\n\\\\t\\" \\"call ___f___hard_smp_processor_id\\\\n\\\\t\\" \\" nop\\\\n\\\\t\\" \\"mov %%g2, %0\\\\n\\\\t\\" : \\"=r\\"( &cpuid) : : \\"g1\\", \\"g2\\");  &cpuid; });
		}' unless defined(&hard_smp_processor_id);
	    }
	    eval 'sub smp_processor_id () {
	        eval q(( &current_thread_info()-> &cpu));
	    }' unless defined(&smp_processor_id);
	    eval 'sub prof_multiplier {
	        local($__cpu) = @_;
    		eval q( &cpu_data($__cpu). &multiplier);
	    }' unless defined(&prof_multiplier);
	    eval 'sub prof_counter {
	        local($__cpu) = @_;
    		eval q( &cpu_data($__cpu). &counter);
	    }' unless defined(&prof_counter);
	}
	eval 'sub MSG_CROSS_CALL () {0x5;}' unless defined(&MSG_CROSS_CALL);
	eval 'sub MBOX_STOPCPU () {0xfb;}' unless defined(&MBOX_STOPCPU);
	eval 'sub MBOX_IDLECPU () {0xfc;}' unless defined(&MBOX_IDLECPU);
	eval 'sub MBOX_IDLECPU2 () {0xfd;}' unless defined(&MBOX_IDLECPU2);
	eval 'sub MBOX_STOPCPU2 () {0xfe;}' unless defined(&MBOX_STOPCPU2);
    }
    eval 'sub NO_PROC_ID () {0xff;}' unless defined(&NO_PROC_ID);
}
1;
