require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_SPINLOCK_H)) {
    eval 'sub __SPARC_SPINLOCK_H () {1;}' unless defined(&__SPARC_SPINLOCK_H);
    require 'linux/threads.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/psr.ph';
	if(defined(&CONFIG_DEBUG_SPINLOCK)) {
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0, 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        local($lp) = @_;
    		eval q( &do { *($lp)=  &SPIN_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        local($lp) = @_;
    		eval q((*(( &volatile \'unsigned char\' *)((($lp)-> &lock))) != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        local($lp) = @_;
    		eval q( &do {  &barrier(); }  &while(*( &volatile \'unsigned char\' *)(($lp)-> &lock)));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_trylock {
	        local($lp) = @_;
    		eval q( &_spin_trylock($lp));
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_lock {
	        local($lock) = @_;
    		eval q( &_do_spin_lock($lock, \\"spin_lock\\"));
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_unlock {
	        local($lock) = @_;
    		eval q( &_do_spin_unlock($lock));
	    }' unless defined(&_raw_spin_unlock);
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0, {0} };}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        local($lp) = @_;
    		eval q( &do { *($lp)=  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub rwlock_is_locked {
	        local($lp) = @_;
    		eval q((($lp)-> &lock != 0));
	    }' unless defined(&rwlock_is_locked);
	    eval 'sub _raw_read_lock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_lock($lock, \\"read_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _raw_read_unlock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_unlock($lock, \\"read_unlock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_lock($lock, \\"write_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_unlock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_unlock);
	} else {
	    eval 'sub SPIN_LOCK_UNLOCKED () {0;}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        local($lock) = @_;
    		eval q((*(($lock)) = 0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        local($lock) = @_;
    		eval q((*(( &volatile \'unsigned char\' *)($lock)) != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        local($lock) = @_;
    		eval q( &do {  &barrier(); }  &while(*(( &volatile \'unsigned char\' *)$lock)));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_lock {
	        local($lock) = @_;
    		eval q({  &__asm__  &__volatile__( \\"\\\\n1:\\\\n\\\\t\\" \\"ldstub	[%0], %%g2\\\\n\\\\t\\" \\"orcc	%%g2, 0x0, %%g0\\\\n\\\\t\\" \\"bne,a	2f\\\\n\\\\t\\" \\" ldub	[%0], %%g2\\\\n\\\\t\\" \\".subsection	2\\\\n\\" \\"2:\\\\n\\\\t\\" \\"orcc	%%g2, 0x0, %%g0\\\\n\\\\t\\" \\"bne,a	2b\\\\n\\\\t\\" \\" ldub	[%0], %%g2\\\\n\\\\t\\" \\"b,a	1b\\\\n\\\\t\\" \\".previous\\\\n\\" : : \\"r\\" ($lock) : \\"g2\\", \\"memory\\", \\"cc\\"); });
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_trylock {
	        local($lock) = @_;
    		eval q({ my $result;  &__asm__  &__volatile__(\\"ldstub [%1], %0\\" : \\"=r\\" ( $result) : \\"r\\" ($lock) : \\"memory\\"); ( $result == 0); });
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_unlock {
	        local($lock) = @_;
    		eval q({  &__asm__  &__volatile__(\\"stb %%g0, [%0]\\" : : \\"r\\" ($lock) : \\"memory\\"); });
	    }' unless defined(&_raw_spin_unlock);
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0};}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        local($lp) = @_;
    		eval q( &do { *($lp)=  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub rwlock_is_locked {
	        local($lp) = @_;
    		eval q((($lp)-> &lock != 0));
	    }' unless defined(&rwlock_is_locked);
	    eval 'sub _raw_read_lock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_read_lock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _read_unlock {
	        local($rw) = @_;
    		eval q({  &register  &rwlock_t * &lp  &asm(\\"g1\\");  &lp = $rw;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___rw_read_exit\\\\n\\\\t\\" \\" ldstub	[%%g1 + 3], %%g2\\\\n\\" : : \\"r\\" ( &lp) : \\"g2\\", \\"g4\\", \\"memory\\", \\"cc\\"); });
	    }' unless defined(&_read_unlock);
	    eval 'sub _raw_read_unlock {
	        local($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_read_unlock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        local($rw) = @_;
    		eval q({  &register  &rwlock_t * &lp  &asm(\\"g1\\");  &lp = $rw;  &__asm__  &__volatile__( \\"mov	%%o7, %%g4\\\\n\\\\t\\" \\"call	___rw_write_enter\\\\n\\\\t\\" \\" ldstub	[%%g1 + 3], %%g2\\\\n\\" : : \\"r\\" ( &lp) : \\"g2\\", \\"g4\\", \\"memory\\", \\"cc\\"); });
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        local($rw) = @_;
    		eval q( &do { ($rw)-> &lock = 0; }  &while(0));
	    }' unless defined(&_raw_write_unlock);
	}
    }
}
1;
