require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_BITOPS_H)) {
    eval 'sub _SPARC64_BITOPS_H () {1;}' unless defined(&_SPARC64_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/byteorder.ph';
    eval 'sub test_and_set_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_set_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_set_bit);
    eval 'sub test_and_clear_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_clear_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_clear_bit);
    eval 'sub test_and_change_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_change_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_change_bit);
    eval 'sub set_bit {
        local($nr,$addr) = @_;
	    eval q((( &void) &___test_and_set_bit($nr,$addr)));
    }' unless defined(&set_bit);
    eval 'sub clear_bit {
        local($nr,$addr) = @_;
	    eval q((( &void) &___test_and_clear_bit($nr,$addr)));
    }' unless defined(&clear_bit);
    eval 'sub change_bit {
        local($nr,$addr) = @_;
	    eval q((( &void) &___test_and_change_bit($nr,$addr)));
    }' unless defined(&change_bit);
    eval 'sub __clear_bit {
        local($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); * &m &= ~(1 << ($nr & 63)); });
    }' unless defined(&__clear_bit);
    eval 'sub __change_bit {
        local($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); * &m ^= (1 << ($nr & 63)); });
    }' unless defined(&__change_bit);
    eval 'sub __test_and_set_bit {
        local($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old |  $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_set_bit);
    eval 'sub __test_and_clear_bit {
        local($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old & ~ $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_clear_bit);
    eval 'sub __test_and_change_bit {
        local($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old ^  $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_change_bit);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &do { }  &while(0));
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &do { }  &while(0));
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub test_bit {
        local($nr,$addr) = @_;
	    eval q({ (1 & (($addr)[$nr >> 6] >> ($nr & 63))) != 0; });
    }' unless defined(&test_bit);
    eval 'sub fls {
        local($x) = @_;
	    eval q( &generic_fls($x));
    }' unless defined(&fls);
    if(defined(&__KERNEL__)) {
	if(defined(&ULTRA_HAS_POPULATION_COUNT)) {
	    eval 'sub hweight64 {
	        local($w) = @_;
    		eval q({ my $res;  &__asm__ (\\"popc %1,%0\\" : \\"=r\\" ( $res) : \\"r\\" ($w));  $res; });
	    }' unless defined(&hweight64);
	    eval 'sub hweight32 {
	        local($w) = @_;
    		eval q({ my $res;  &__asm__ (\\"popc %1,%0\\" : \\"=r\\" ( $res) : \\"r\\" ($w & 0xffffffff));  $res; });
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        local($w) = @_;
    		eval q({ my $res;  &__asm__ (\\"popc %1,%0\\" : \\"=r\\" ( $res) : \\"r\\" ($w & 0xffff));  $res; });
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        local($w) = @_;
    		eval q({ my $res;  &__asm__ (\\"popc %1,%0\\" : \\"=r\\" ( $res) : \\"r\\" ($w & 0xff));  $res; });
	    }' unless defined(&hweight8);
	} else {
	    eval 'sub hweight64 {
	        local($x) = @_;
    		eval q( &generic_hweight64($x));
	    }' unless defined(&hweight64);
	    eval 'sub hweight32 {
	        local($x) = @_;
    		eval q( &generic_hweight32($x));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        local($x) = @_;
    		eval q( &generic_hweight16($x));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        local($x) = @_;
    		eval q( &generic_hweight8($x));
	    }' unless defined(&hweight8);
	}
    }
    eval 'sub find_first_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_bit(($addr), ($size), 0));
    }' unless defined(&find_first_bit);
    eval 'sub find_first_zero_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub test_and_set_le_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_set_le_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_set_le_bit);
    eval 'sub test_and_clear_le_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_clear_le_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_clear_le_bit);
    eval 'sub set_le_bit {
        local($nr,$addr) = @_;
	    eval q((( &void) &___test_and_set_le_bit($nr,$addr)));
    }' unless defined(&set_le_bit);
    eval 'sub clear_le_bit {
        local($nr,$addr) = @_;
	    eval q((( &void) &___test_and_clear_le_bit($nr,$addr)));
    }' unless defined(&clear_le_bit);
    eval 'sub test_le_bit {
        local($nr,$addr) = @_;
	    eval q({ \'int\'  &mask;  &__const__ my $char * &ADDR = ( &__const__ my $char *) $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7); (( &mask & * &ADDR) != 0); });
    }' unless defined(&test_le_bit);
    eval 'sub find_first_zero_le_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_le_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_le_bit);
    eval 'sub find_next_zero_le_bit {
        local($addr,$size,$offset) = @_;
	    eval q({ my $long * &p = $addr + ($offset >> 6); my $result = $offset & ~63; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 63;  &if($offset) {  $tmp =  &__swab64p( &p++);  $tmp |= (~0 >> (64-$offset));  &if($size < 64)  &goto  &found_first;  &if(~ $tmp)  &goto  &found_middle; $size -= 64;  $result += 64; }  &while($size & ~63) {  &if(~( $tmp =  &__swab64p( &p++)))  &goto  &found_middle;  $result += 64; $size -= 64; }  &if(!$size)  $result;  $tmp =  &__swab64p( &p);  &found_first:  $tmp |= (~0 << $size);  &if ( $tmp == ~0)  $result + $size;  &found_middle:  $result +  &ffz( $tmp); });
    }' unless defined(&find_next_zero_le_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub ext2_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_le_bit(,($addr)));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_set_bit_atomic {
	    local($lock,$nr,$addr) = @_;
    	    eval q( &test_and_set_le_bit(,($addr)));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_le_bit(,($addr)));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_clear_bit_atomic {
	    local($lock,$nr,$addr) = @_;
    	    eval q( &test_and_clear_le_bit(,($addr)));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_le_bit(,($addr)));
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_first_zero_le_bit(($addr), ($size)));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    local($addr, $size, $off) = @_;
    	    eval q( &find_next_zero_le_bit(($addr), ($size), ($off)));
	}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_bit(,($addr)));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &set_bit(,($addr)));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit(,($addr)));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_bit(,($addr)));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_first_zero_bit(($addr),($size)));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
