require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_RWSEM_H)) {
    eval 'sub _SPARC64_RWSEM_H () {1;}' unless defined(&_SPARC64_RWSEM_H);
    unless(defined(&_LINUX_RWSEM_H)) {
	die("please don't include asm/rwsem.h directly, use linux/rwsem.h instead");
    }
    if(defined(&__KERNEL__)) {
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	eval 'sub RWSEM_UNLOCKED_VALUE () {0x;}' unless defined(&RWSEM_UNLOCKED_VALUE);
	eval 'sub RWSEM_ACTIVE_BIAS () {0x1;}' unless defined(&RWSEM_ACTIVE_BIAS);
	eval 'sub RWSEM_ACTIVE_MASK () {0xffff;}' unless defined(&RWSEM_ACTIVE_MASK);
	eval 'sub RWSEM_WAITING_BIAS () {0xffff0000;}' unless defined(&RWSEM_WAITING_BIAS);
	eval 'sub RWSEM_ACTIVE_READ_BIAS () { &RWSEM_ACTIVE_BIAS;}' unless defined(&RWSEM_ACTIVE_READ_BIAS);
	eval 'sub RWSEM_ACTIVE_WRITE_BIAS () {( &RWSEM_WAITING_BIAS +  &RWSEM_ACTIVE_BIAS);}' unless defined(&RWSEM_ACTIVE_WRITE_BIAS);
	eval 'sub __RWSEM_INITIALIZER {
	    local($name) = @_;
    	    eval q({  &RWSEM_UNLOCKED_VALUE,  &SPIN_LOCK_UNLOCKED,  &LIST_HEAD_INIT(($name). &wait_list) });
	}' unless defined(&__RWSEM_INITIALIZER);
	eval 'sub DECLARE_RWSEM {
	    local($name) = @_;
    	    eval q(\'struct rw_semaphore\' $name =  &__RWSEM_INITIALIZER($name));
	}' unless defined(&DECLARE_RWSEM);
	eval 'sub init_rwsem {
	    local($sem) = @_;
    	    eval q({  ($sem->{count}) =  &RWSEM_UNLOCKED_VALUE;  &spin_lock_init( ($sem->{wait_lock}));  &INIT_LIST_HEAD( ($sem->{wait_list})); });
	}' unless defined(&init_rwsem);
	eval 'sub rwsem_atomic_update {
	    local($delta,$sem) = @_;
    	    eval q({ \'int\'  &tmp = $delta;  &__asm__  &__volatile__( \\"1:\\\\tlduw	[%2], %%g5\\\\n\\\\t\\" \\"add		%%g5, %1, %%g7\\\\n\\\\t\\" \\"cas		[%2], %%g5, %%g7\\\\n\\\\t\\" \\"cmp		%%g5, %%g7\\\\n\\\\t\\" \\"bne,pn		%%icc, 1b\\\\n\\\\t\\" \\" membar	#StoreLoad | #StoreStore\\\\n\\\\t\\" \\"mov		%%g7, %0\\\\n\\\\t\\" : \\"=&r\\" ( &tmp) : \\"0\\" ( &tmp), \\"r\\" ($sem) : \\"g5\\", \\"g7\\", \\"memory\\", \\"cc\\");  &tmp + $delta; });
	}' unless defined(&rwsem_atomic_update);
	eval 'sub rwsem_atomic_add () { &rwsem_atomic_update;}' unless defined(&rwsem_atomic_add);
	eval 'sub rwsem_cmpxchgw {
	    local($sem,$__old,$__new) = @_;
    	    eval q({  &u32  &old = ( ($sem->{count}) & 0xffff0000) | ( &u32) $__old;  &u32  &new = ( &old & 0xffff0000) | ( &u32) $__new;  &u32  &prev;  &again:  &__asm__  &__volatile__(\\"cas	[%2], %3, %0\\\\n\\\\t\\" \\"membar	#StoreLoad | #StoreStore\\" : \\"=&r\\" ( &prev) : \\"0\\" ( &new), \\"r\\" ($sem), \\"r\\" ( &old) : \\"memory\\");  &if ( &prev !=  &old  && (( &prev & 0xffff) == ( &old & 0xffff)))  &goto  &again;  &prev & 0xffff; });
	}' unless defined(&rwsem_cmpxchgw);
	eval 'sub rwsem_cmpxchg {
	    local($sem,$old,$new) = @_;
    	    eval q({  &cmpxchg( ($sem->{count}),$old,$new); });
	}' unless defined(&rwsem_cmpxchg);
    }
}
1;
