require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_SPITFIRE_H)) {
    eval 'sub _SPARC64_SPITFIRE_H () {1;}' unless defined(&_SPARC64_SPITFIRE_H);
    require 'asm/asi.ph';
    eval 'sub TSB_TAG_TARGET () {0x;}' unless defined(&TSB_TAG_TARGET);
    eval 'sub TLB_SFSR () {0x18;}' unless defined(&TLB_SFSR);
    eval 'sub TSB_REG () {0x28;}' unless defined(&TSB_REG);
    eval 'sub TLB_TAG_ACCESS () {0x30;}' unless defined(&TLB_TAG_ACCESS);
    eval 'sub VIRT_WATCHPOINT () {0x38;}' unless defined(&VIRT_WATCHPOINT);
    eval 'sub PHYS_WATCHPOINT () {0x40;}' unless defined(&PHYS_WATCHPOINT);
    eval 'sub TSB_EXTENSION_P () {0x48;}' unless defined(&TSB_EXTENSION_P);
    eval 'sub TSB_EXTENSION_S () {0x50;}' unless defined(&TSB_EXTENSION_S);
    eval 'sub TSB_EXTENSION_N () {0x58;}' unless defined(&TSB_EXTENSION_N);
    eval 'sub TLB_TAG_ACCESS_EXT () {0x60;}' unless defined(&TLB_TAG_ACCESS_EXT);
    eval 'sub PRIMARY_CONTEXT () {0x8;}' unless defined(&PRIMARY_CONTEXT);
    eval 'sub SECONDARY_CONTEXT () {0x10;}' unless defined(&SECONDARY_CONTEXT);
    eval 'sub DMMU_SFAR () {0x20;}' unless defined(&DMMU_SFAR);
    eval 'sub VIRT_WATCHPOINT () {0x38;}' unless defined(&VIRT_WATCHPOINT);
    eval 'sub PHYS_WATCHPOINT () {0x40;}' unless defined(&PHYS_WATCHPOINT);
    eval 'sub SPITFIRE_HIGHEST_LOCKED_TLBENT () {(64- 1);}' unless defined(&SPITFIRE_HIGHEST_LOCKED_TLBENT);
    unless(defined(&__ASSEMBLY__)) {
	eval("sub spitfire () { 0; }") unless defined(&spitfire);
	eval("sub cheetah () { 1; }") unless defined(&cheetah);
	eval("sub cheetah_plus () { 2; }") unless defined(&cheetah_plus);
	eval 'sub CHEETAH_HIGHEST_LOCKED_TLBENT () {(16- 1);}' unless defined(&CHEETAH_HIGHEST_LOCKED_TLBENT);
	eval 'sub L1DCACHE_SIZE () {0x4000;}' unless defined(&L1DCACHE_SIZE);
	eval 'sub sparc64_highest_locked_tlbent () {
	    eval q(( &tlb_type ==  &spitfire ?  &SPITFIRE_HIGHEST_LOCKED_TLBENT :  &CHEETAH_HIGHEST_LOCKED_TLBENT));
	}' unless defined(&sparc64_highest_locked_tlbent);
	eval 'sub spitfire_get_isfsr {
	    local($void) = @_;
    	    eval q({ my $ret;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $ret) : \\"r\\" ( &TLB_SFSR), \\"i\\" ( &ASI_IMMU));  $ret; });
	}' unless defined(&spitfire_get_isfsr);
	eval 'sub spitfire_get_dsfsr {
	    local($void) = @_;
    	    eval q({ my $ret;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $ret) : \\"r\\" ( &TLB_SFSR), \\"i\\" ( &ASI_DMMU));  $ret; });
	}' unless defined(&spitfire_get_dsfsr);
	eval 'sub spitfire_get_sfar {
	    local($void) = @_;
    	    eval q({ my $ret;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $ret) : \\"r\\" ( &DMMU_SFAR), \\"i\\" ( &ASI_DMMU));  $ret; });
	}' unless defined(&spitfire_get_sfar);
	eval 'sub spitfire_put_isfsr {
	    local($sfsr) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($sfsr), \\"r\\" ( &TLB_SFSR), \\"i\\" ( &ASI_IMMU)); });
	}' unless defined(&spitfire_put_isfsr);
	eval 'sub spitfire_put_dsfsr {
	    local($sfsr) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($sfsr), \\"r\\" ( &TLB_SFSR), \\"i\\" ( &ASI_DMMU)); });
	}' unless defined(&spitfire_put_dsfsr);
	eval 'sub spitfire_get_primary_context {
	    local($void) = @_;
    	    eval q({ my $ctx;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $ctx) : \\"r\\" ( &PRIMARY_CONTEXT), \\"i\\" ( &ASI_DMMU));  $ctx; });
	}' unless defined(&spitfire_get_primary_context);
	eval 'sub spitfire_set_primary_context {
	    local($ctx) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($ctx & 0x3ff), \\"r\\" ( &PRIMARY_CONTEXT), \\"i\\" ( &ASI_DMMU));  &__asm__  &__volatile__ (\\"membar #Sync\\" : : : \\"memory\\"); });
	}' unless defined(&spitfire_set_primary_context);
	eval 'sub spitfire_get_secondary_context {
	    local($void) = @_;
    	    eval q({ my $ctx;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $ctx) : \\"r\\" ( &SECONDARY_CONTEXT), \\"i\\" ( &ASI_DMMU));  $ctx; });
	}' unless defined(&spitfire_get_secondary_context);
	eval 'sub spitfire_set_secondary_context {
	    local($ctx) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($ctx & 0x3ff), \\"r\\" ( &SECONDARY_CONTEXT), \\"i\\" ( &ASI_DMMU));  &__asm__  &__volatile__ (\\"membar #Sync\\" : : : \\"memory\\"); });
	}' unless defined(&spitfire_set_secondary_context);
	eval 'sub spitfire_get_dtlb_data {
	    local($entry) = @_;
    	    eval q({ my $data;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $data) : \\"r\\" ($entry << 3), \\"i\\" ( &ASI_DTLB_DATA_ACCESS));  $data &= ~1.12370088358707e+15;  $data; });
	}' unless defined(&spitfire_get_dtlb_data);
	eval 'sub spitfire_get_dtlb_tag {
	    local($entry) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" ($entry << 3), \\"i\\" ( &ASI_DTLB_TAG_READ));  $tag; });
	}' unless defined(&spitfire_get_dtlb_tag);
	eval 'sub spitfire_put_dtlb_data {
	    local($entry,$data) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" ($entry << 3), \\"i\\" ( &ASI_DTLB_DATA_ACCESS)); });
	}' unless defined(&spitfire_put_dtlb_data);
	eval 'sub spitfire_get_itlb_data {
	    local($entry) = @_;
    	    eval q({ my $data;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $data) : \\"r\\" ($entry << 3), \\"i\\" ( &ASI_ITLB_DATA_ACCESS));  $data &= ~1.12370088358707e+15;  $data; });
	}' unless defined(&spitfire_get_itlb_data);
	eval 'sub spitfire_get_itlb_tag {
	    local($entry) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" ($entry << 3), \\"i\\" ( &ASI_ITLB_TAG_READ));  $tag; });
	}' unless defined(&spitfire_get_itlb_tag);
	eval 'sub spitfire_put_itlb_data {
	    local($entry,$data) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" ($entry << 3), \\"i\\" ( &ASI_ITLB_DATA_ACCESS)); });
	}' unless defined(&spitfire_put_itlb_data);
	eval 'sub spitfire_flush_itlb_primary_context {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x40), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_primary_context);
	eval 'sub spitfire_flush_dtlb_secondary_context {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x50), \\"i\\" ( &ASI_DMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_dtlb_secondary_context);
	eval 'sub spitfire_flush_itlb_secondary_context {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x50), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_secondary_context);
	eval 'sub spitfire_flush_dtlb_nucleus_context {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x60), \\"i\\" ( &ASI_DMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_dtlb_nucleus_context);
	eval 'sub spitfire_flush_itlb_nucleus_context {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x60), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_nucleus_context);
	eval 'sub spitfire_flush_itlb_primary_page {
	    local($page) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($page), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_primary_page);
	eval 'sub spitfire_flush_dtlb_secondary_page {
	    local($page) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($page | 0x10), \\"i\\" ( &ASI_DMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_dtlb_secondary_page);
	eval 'sub spitfire_flush_itlb_secondary_page {
	    local($page) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($page | 0x10), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_secondary_page);
	eval 'sub spitfire_flush_dtlb_nucleus_page {
	    local($page) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($page | 0x20), \\"i\\" ( &ASI_DMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_dtlb_nucleus_page);
	eval 'sub spitfire_flush_itlb_nucleus_page {
	    local($page) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($page | 0x20), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&spitfire_flush_itlb_nucleus_page);
	eval 'sub cheetah_flush_itlb_all {
	    local($void) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%%g0, [%0] %1\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" (0x80), \\"i\\" ( &ASI_IMMU_DEMAP)); });
	}' unless defined(&cheetah_flush_itlb_all);
	eval 'sub cheetah_get_litlb_data {
	    local($entry) = @_;
    	    eval q({ my $data;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %%g0\\\\n\\\\t\\" \\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $data) : \\"r\\" ((0<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_DATA_ACCESS));  $data; });
	}' unless defined(&cheetah_get_litlb_data);
	eval 'sub cheetah_get_ldtlb_tag {
	    local($entry) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" ((0<< 16) | ($entry << 3)), \\"i\\" ( &ASI_DTLB_TAG_READ));  $tag; });
	}' unless defined(&cheetah_get_ldtlb_tag);
	eval 'sub cheetah_get_litlb_tag {
	    local($entry) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" ((0<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_TAG_READ));  $tag; });
	}' unless defined(&cheetah_get_litlb_tag);
	eval 'sub cheetah_put_ldtlb_data {
	    local($entry,$data) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" ((0<< 16) | ($entry << 3)), \\"i\\" ( &ASI_DTLB_DATA_ACCESS)); });
	}' unless defined(&cheetah_put_ldtlb_data);
	eval 'sub cheetah_put_litlb_data {
	    local($entry,$data) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" ((0<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_DATA_ACCESS)); });
	}' unless defined(&cheetah_put_litlb_data);
	eval 'sub cheetah_get_dtlb_data {
	    local($entry,$tlb) = @_;
    	    eval q({ my $data;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %%g0\\\\n\\\\t\\" \\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $data) : \\"r\\" (($tlb << 16) | ($entry << 3)), \\"i\\" ( &ASI_DTLB_DATA_ACCESS));  $data; });
	}' unless defined(&cheetah_get_dtlb_data);
	eval 'sub cheetah_get_dtlb_tag {
	    local($entry,$tlb) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" (($tlb << 16) | ($entry << 3)), \\"i\\" ( &ASI_DTLB_TAG_READ));  $tag; });
	}' unless defined(&cheetah_get_dtlb_tag);
	eval 'sub cheetah_put_dtlb_data {
	    local($entry,$data,$tlb) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" (($tlb << 16) | ($entry << 3)), \\"i\\" ( &ASI_DTLB_DATA_ACCESS)); });
	}' unless defined(&cheetah_put_dtlb_data);
	eval 'sub cheetah_get_itlb_data {
	    local($entry) = @_;
    	    eval q({ my $data;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %%g0\\\\n\\\\t\\" \\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $data) : \\"r\\" ((2<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_DATA_ACCESS));  $data; });
	}' unless defined(&cheetah_get_itlb_data);
	eval 'sub cheetah_get_itlb_tag {
	    local($entry) = @_;
    	    eval q({ my $tag;  &__asm__  &__volatile__(\\"ldxa	[%1] %2, %0\\" : \\"=r\\" ( $tag) : \\"r\\" ((2<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_TAG_READ));  $tag; });
	}' unless defined(&cheetah_get_itlb_tag);
	eval 'sub cheetah_put_itlb_data {
	    local($entry,$data) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"membar	#Sync\\" : : \\"r\\" ($data), \\"r\\" ((2<< 16) | ($entry << 3)), \\"i\\" ( &ASI_ITLB_DATA_ACCESS)); });
	}' unless defined(&cheetah_put_itlb_data);
    }
}
1;
