require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_SYSTEM_H)) {
    eval 'sub __SPARC64_SYSTEM_H () {1;}' unless defined(&__SPARC64_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/ptrace.ph';
    require 'asm/processor.ph';
    require 'asm/visasm.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval("sub sun4 () { 0x00; }") unless defined(&sun4);
	eval("sub sun4c () { 0x01; }") unless defined(&sun4c);
	eval("sub sun4m () { 0x02; }") unless defined(&sun4m);
	eval("sub sun4d () { 0x03; }") unless defined(&sun4d);
	eval("sub sun4e () { 0x04; }") unless defined(&sun4e);
	eval("sub sun4u () { 0x05; }") unless defined(&sun4u);
	eval("sub sun_unknown () { 0x06; }") unless defined(&sun_unknown);
	eval("sub ap1000 () { 0x07; }") unless defined(&ap1000);
	eval 'sub sparc_cpu_model () { &sun4u;}' unless defined(&sparc_cpu_model);
	eval 'sub ARCH_SUN4C_SUN4 () {0;}' unless defined(&ARCH_SUN4C_SUN4);
	eval 'sub ARCH_SUN4 () {0;}' unless defined(&ARCH_SUN4);
    }
    eval 'sub setipl {
        local($__new_ipl) = @_;
	    eval q( &__asm__  &__volatile__(\\"wrpr	%0, %%pil\\" : : \\"r\\" ($__new_ipl) : \\"memory\\"));
    }' unless defined(&setipl);
    eval 'sub local_irq_disable () {
        eval q( &__asm__  &__volatile__(\\"wrpr	15, %%pil\\" : : : \\"memory\\"));
    }' unless defined(&local_irq_disable);
    eval 'sub local_irq_enable () {
        eval q( &__asm__  &__volatile__(\\"wrpr	0, %%pil\\" : : : \\"memory\\"));
    }' unless defined(&local_irq_enable);
    eval 'sub getipl () {
        eval q(({ \'unsigned long retval\';  &__asm__  &__volatile__(\\"rdpr	%%pil, %0\\" : \\"=r\\" ( &retval));  &retval; }));
    }' unless defined(&getipl);
    eval 'sub swap_pil {
        local($__new_pil) = @_;
	    eval q(({ \'unsigned long retval\';  &__asm__  &__volatile__(\\"rdpr	%%pil, %0\\\\n\\\\t\\" \\"wrpr	%1, %%pil\\" : \\"=&r\\" ( &retval) : \\"r\\" ($__new_pil) : \\"memory\\");  &retval; }));
    }' unless defined(&swap_pil);
    eval 'sub read_pil_and_cli () {
        eval q(({ \'unsigned long retval\';  &__asm__  &__volatile__(\\"rdpr	%%pil, %0\\\\n\\\\t\\" \\"wrpr	15, %%pil\\" : \\"=r\\" ( &retval) : : \\"memory\\");  &retval; }));
    }' unless defined(&read_pil_and_cli);
    eval 'sub local_save_flags {
        local($flags) = @_;
	    eval q((($flags) =  &getipl()));
    }' unless defined(&local_save_flags);
    eval 'sub local_irq_save {
        local($flags) = @_;
	    eval q((($flags) =  &read_pil_and_cli()));
    }' unless defined(&local_irq_save);
    eval 'sub local_irq_restore {
        local($flags) = @_;
	    eval q( &setipl(($flags)));
    }' unless defined(&local_irq_restore);
    eval 'sub irqs_disabled () {
        eval q(({ \'unsigned long flags\';  &local_save_flags( &flags); ( &flags > 0); }));
    }' unless defined(&irqs_disabled);
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub membar {
        local($type) = @_;
	    eval q( &__asm__  &__volatile__ (\\"membar \\" $type : : : \\"memory\\"););
    }' unless defined(&membar);
    eval 'sub mb () {
        eval q( &membar(\\"#LoadLoad | #LoadStore | #StoreStore | #StoreLoad\\"););
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &membar(\\"#LoadLoad\\"));
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &membar(\\"#StoreStore\\"));
    }' unless defined(&wmb);
    eval 'sub read_barrier_depends () {
        eval q( &do { }  &while(0));
    }' unless defined(&read_barrier_depends);
    eval 'sub set_mb {
        local($__var, $__value) = @_;
	    eval q( &do { $__var = $__value;  &membar(\\"#StoreLoad | #StoreStore\\"); }  &while(0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        local($__var, $__value) = @_;
	    eval q( &do { $__var = $__value;  &membar(\\"#StoreStore\\"); }  &while(0));
    }' unless defined(&set_wmb);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &read_barrier_depends());
	}' unless defined(&smp_read_barrier_depends);
    } else {
	eval 'sub smp_mb () {
	    eval q( &__asm__  &__volatile__(\\"\\":::\\"memory\\"););
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &__asm__  &__volatile__(\\"\\":::\\"memory\\"););
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &__asm__  &__volatile__(\\"\\":::\\"memory\\"););
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_read_barrier_depends);
    }
    eval 'sub flushi {
        local($addr) = @_;
	    eval q( &__asm__  &__volatile__ (\\"flush %0\\" : : \\"r\\" ($addr) : \\"memory\\"));
    }' unless defined(&flushi);
    eval 'sub flushw_all () {
        eval q( &__asm__  &__volatile__(\\"flushw\\"));
    }' unless defined(&flushw_all);
    eval 'sub read_pcr {
        local($__p) = @_;
	    eval q( &__asm__  &__volatile__(\\"rd	%%pcr, %0\\" : \\"=r\\" ($__p)));
    }' unless defined(&read_pcr);
    eval 'sub write_pcr {
        local($__p) = @_;
	    eval q( &__asm__  &__volatile__(\\"wr	%0, 0x0, %%pcr\\" : : \\"r\\" ($__p)););
    }' unless defined(&write_pcr);
    eval 'sub read_pic {
        local($__p) = @_;
	    eval q( &__asm__  &__volatile__(\\"rd %%pic, %0\\" : \\"=r\\" ($__p)));
    }' unless defined(&read_pic);
    eval 'sub reset_pic () {
        eval q( &__asm__  &__volatile__(\\"ba,pt	%xcc, 99f\\\\n\\\\t\\" \\".align	64\\\\n\\" \\"99:wr	%g0, 0x0, %pic\\\\n\\\\t\\" \\"rd	%pic, %g0\\"));
    }' unless defined(&reset_pic);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub con_is_present {
	    local($void) = @_;
    	    eval q({  &serial_console ? 0: 1; });
	}' unless defined(&con_is_present);
	eval 'sub flushw_user () {
	    eval q( &__flushw_user());
	}' unless defined(&flushw_user);
	eval 'sub flush_user_windows () { &flushw_user;}' unless defined(&flush_user_windows);
	eval 'sub flush_register_windows () { &flushw_all;}' unless defined(&flush_register_windows);
	eval 'sub prepare_arch_switch {
	    local($rq, $next) = @_;
    	    eval q( &do {  &spin_lock(($next)-> &switch_lock);  &spin_unlock(($rq)-> &lock);  &flushw_all(); }  &while (0));
	}' unless defined(&prepare_arch_switch);
	eval 'sub finish_arch_switch {
	    local($rq, $prev) = @_;
    	    eval q( &do {  &spin_unlock_irq(($prev)-> &switch_lock); }  &while (0));
	}' unless defined(&finish_arch_switch);
	eval 'sub task_running {
	    local($rq, $p) = @_;
    	    eval q((($rq)-> &curr == ($p) ||  &spin_is_locked(($p)-> &switch_lock)));
	}' unless defined(&task_running);
	if((defined(&__GNUC__) ? &__GNUC__ : 0) >= 3) {
	    eval 'sub EXTRA_CLOBBER () {,"%l1";}' unless defined(&EXTRA_CLOBBER);
	} else {
	    eval 'sub EXTRA_CLOBBER () {1;}' unless defined(&EXTRA_CLOBBER);
	}
	eval 'sub switch_to {
	    local($prev, $next, $last) = @_;
    	    eval q( &do {  &if ( &test_thread_flag( &TIF_PERFCTR)) { \'unsigned long __tmp\';  &read_pcr( &__tmp);  &current_thread_info()-> &pcr_reg =  &__tmp;  &read_pic( &__tmp);  &current_thread_info()-> &kernel_cntd0 += ( &__tmp);  &current_thread_info()-> &kernel_cntd1 += (( &__tmp) >> 32); }  &save_and_clear_fpu();  &__asm__  &__volatile__(\\"wr %%g0, %0, %%asi\\" : : \\"r\\" ( &__thread_flag_byte_ptr( ($next->{thread_info}))[ &TI_FLAG_BYTE_CURRENT_DS]));  &__asm__  &__volatile__( \\"mov	%%g4, %%g5\\\\n\\\\t\\" \\"wrpr	%%g0, 0x95, %%pstate\\\\n\\\\t\\" \\"stx	%%i6, [%%sp + 2047 + 0x70]\\\\n\\\\t\\" \\"stx	%%i7, [%%sp + 2047 + 0x78]\\\\n\\\\t\\" \\"rdpr	%%wstate, %%o5\\\\n\\\\t\\" \\"stx	%%o6, [%%g6 + %3]\\\\n\\\\t\\" \\"stb	%%o5, [%%g6 + %2]\\\\n\\\\t\\" \\"rdpr	%%cwp, %%o5\\\\n\\\\t\\" \\"stb	%%o5, [%%g6 + %5]\\\\n\\\\t\\" \\"mov	%1, %%g6\\\\n\\\\t\\" \\"ldub	[%1 + %5], %%g1\\\\n\\\\t\\" \\"wrpr	%%g1, %%cwp\\\\n\\\\t\\" \\"ldx	[%%g6 + %3], %%o6\\\\n\\\\t\\" \\"ldub	[%%g6 + %2], %%o5\\\\n\\\\t\\" \\"ldx	[%%g6 + %4], %%o7\\\\n\\\\t\\" \\"mov	%%g6, %%l2\\\\n\\\\t\\" \\"wrpr	%%o5, 0x0, %%wstate\\\\n\\\\t\\" \\"ldx	[%%sp + 2047 + 0x70], %%i6\\\\n\\\\t\\" \\"ldx	[%%sp + 2047 + 0x78], %%i7\\\\n\\\\t\\" \\"wrpr	%%g0, 0x94, %%pstate\\\\n\\\\t\\" \\"mov	%%l2, %%g6\\\\n\\\\t\\" \\"ldx	[%%g6 + %7], %%g4\\\\n\\\\t\\" \\"wrpr	%%g0, 0x96, %%pstate\\\\n\\\\t\\" \\"andcc	%%o7, %6, %%g0\\\\n\\\\t\\" \\"bne,pn	%%icc, ret_from_syscall\\\\n\\\\t\\" \\" mov	%%g5, %0\\\\n\\\\t\\" : \\"=&r\\" ($last) : \\"0\\" ( ($next->{thread_info})), \\"i\\" ( &TI_WSTATE), \\"i\\" ( &TI_KSP), \\"i\\" ( &TI_FLAGS), \\"i\\" ( &TI_CWP), \\"i\\" ( &_TIF_NEWCHILD), \\"i\\" ( &TI_TASK) : \\"cc\\", \\"g1\\", \\"g2\\", \\"g3\\", \\"g5\\", \\"g7\\", \\"l2\\", \\"l3\\", \\"l4\\", \\"l5\\", \\"l6\\", \\"l7\\", \\"i0\\", \\"i1\\", \\"i2\\", \\"i3\\", \\"i4\\", \\"i5\\", \\"o0\\", \\"o1\\", \\"o2\\", \\"o3\\", \\"o4\\", \\"o5\\", \\"o7\\"  &EXTRA_CLOBBER);  &if ( &test_thread_flag( &TIF_PERFCTR)) {  &write_pcr( &current_thread_info()-> &pcr_reg);  &reset_pic(); } }  &while(0));
	}' unless defined(&switch_to);
	eval 'sub xchg32 {
	    local($m,$val) = @_;
    	    eval q({  &__asm__  &__volatile__( \\"	mov		%0, %%g5\\\\n\\" \\"1:	lduw		[%2], %%g7\\\\n\\" \\"	cas		[%2], %%g7, %0\\\\n\\" \\"	cmp		%%g7, %0\\\\n\\" \\"	bne,a,pn	%%icc, 1b\\\\n\\" \\"	 mov		%%g5, %0\\\\n\\" \\"	membar		#StoreLoad | #StoreStore\\\\n\\" : \\"=&r\\" ($val) : \\"0\\" ($val), \\"r\\" ($m) : \\"g5\\", \\"g7\\", \\"cc\\", \\"memory\\"); $val; });
	}' unless defined(&xchg32);
	eval 'sub xchg64 {
	    local($m,$val) = @_;
    	    eval q({  &__asm__  &__volatile__( \\"	mov		%0, %%g5\\\\n\\" \\"1:	ldx		[%2], %%g7\\\\n\\" \\"	casx		[%2], %%g7, %0\\\\n\\" \\"	cmp		%%g7, %0\\\\n\\" \\"	bne,a,pn	%%xcc, 1b\\\\n\\" \\"	 mov		%%g5, %0\\\\n\\" \\"	membar		#StoreLoad | #StoreStore\\\\n\\" : \\"=&r\\" ($val) : \\"0\\" ($val), \\"r\\" ($m) : \\"g5\\", \\"g7\\", \\"cc\\", \\"memory\\"); $val; });
	}' unless defined(&xchg64);
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q((( &__typeof__(*($ptr))) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub tas {
	    local($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub __xchg {
	    local($x,$ptr,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &xchg32($ptr, $x);  &case 8:  &xchg64($ptr, $x); };  &__xchg_called_with_bad_pointer(); $x; });
	}' unless defined(&__xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	eval 'sub __cmpxchg_u32 {
	    local($m,$old,$new) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"cas [%2], %3, %0\\\\n\\\\t\\" \\"membar #StoreLoad | #StoreStore\\" : \\"=&r\\" ($new) : \\"0\\" ($new), \\"r\\" ($m), \\"r\\" ($old) : \\"memory\\"); $new; });
	}' unless defined(&__cmpxchg_u32);
	eval 'sub __cmpxchg_u64 {
	    local($m,$old,$new) = @_;
    	    eval q({  &__asm__  &__volatile__(\\"casx [%2], %3, %0\\\\n\\\\t\\" \\"membar #StoreLoad | #StoreStore\\" : \\"=&r\\" ($new) : \\"0\\" ($new), \\"r\\" ($m), \\"r\\" ($old) : \\"memory\\"); $new; });
	}' unless defined(&__cmpxchg_u64);
	eval 'sub __cmpxchg {
	    local($ptr,$old,$new,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__cmpxchg_u32($ptr, $old, $new);  &case 8:  &__cmpxchg_u64($ptr, $old, $new); }  &__cmpxchg_called_with_bad_pointer(); $old; });
	}' unless defined(&__cmpxchg);
	eval 'sub cmpxchg {
	    local($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*($ptr))  &_o_ = ($o);  &__typeof__(*($ptr))  &_n_ = ($n); ( &__typeof__(*($ptr)))  &__cmpxchg(($ptr),  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
    }
}
1;
